Index: /LMDZ.3.3/branches/rel-LF/libf/phylmd/clmain.F
===================================================================
--- /LMDZ.3.3/branches/rel-LF/libf/phylmd/clmain.F	(revision 142)
+++ /LMDZ.3.3/branches/rel-LF/libf/phylmd/clmain.F	(revision 143)
@@ -313,5 +313,5 @@
      .            yts, yrugos, yu, yv, yt, yq,
      .            ycoefm, ycoefh)
-      CALL coefkz2(nsrf, knon, paprs, pplay,t,
+      CALL coefkz2(nsrf, knon, ypaprs, ypplay,yt,
      .                  ycoefm0, ycoefh0)
       DO k = 1, klev
@@ -705,5 +705,5 @@
      s evap, fluxsens, fluxlat, dflux_l, dflux_s,              
      s tsol_rad, tsurf_new, alb_new, emis_new, z0_new, 
-     s pctsrf_NEW, agesno)
+     s pctsrf_new, agesno)
 
       flux_t(:,1) = fluxsens
Index: /LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90
===================================================================
--- /LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90	(revision 142)
+++ /LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90	(revision 143)
@@ -792,9 +792,10 @@
       call abort_gcm(modname,abort_message,1)
     endif
-    allocate(pctsrf_sav(klon,2), stat = error)
+    allocate(pctsrf_sav(klon,nbsrf), stat = error)
     if ( error  /=0) then
       abort_message='Pb allocation variable pctsrf_sav'
       call abort_gcm(modname,abort_message,1)
     endif
+    pctsrf_sav = 0.
 
     do ig = 1, klon
@@ -909,33 +910,28 @@
       IF (pctsrf(ig,is_oce) > epsfra .OR.            &
      &             pctsrf(ig,is_sic) > epsfra) THEN
-            pctsrf_sav(ig,is_sic) = tamp_sic(ig) * pctsrf(ig,is_sic)
-            pctsrf_sav(ig,is_oce) = pctsrf(ig,is_oce)    &
-     &                        - (pctsrf_sav(ig,is_sic)-pctsrf(ig,is_sic))
+          pctsrf_sav(ig,is_sic) = (pctsrf(ig,is_oce) + pctsrf(ig,is_sic)) &
+     &                               * tamp_sic(ig)
+          pctsrf_sav(ig,is_oce) = (pctsrf(ig,is_oce) + pctsrf(ig,is_sic)) &
+     &                        - pctsrf_sav(ig,is_sic)
+        endif
+      enddo
+      if (check) then
+        write(46,*)'pct_srf_sav_ice = '
+        write(46,'(72f8.3)')pctsrf_sav(:,is_sic)
       endif
-    enddo
-    if (minval(pctsrf_new(:,is_oce)) < 0.) then
-      write(*,*)'Pb fraction ocean inferieure a 0'
-      write(*,*)'au point ',minloc(pctsrf_new(:,is_oce))
-      write(*,*)'valeur = ',minval(pctsrf_new(:,is_oce)) 
-      abort_message = 'voir ci-dessus'
-      call abort_gcm(modname,abort_message,1)
-    endif
-    if (minval(pctsrf_new(:,is_sic)) < 0.) then
-      write(*,*)'Pb fraction glace inferieure a 0'
-      write(*,*)'au point ',minloc(pctsrf_new(:,is_sic))
-      write(*,*)'valeur = ',minval(pctsrf_new(:,is_sic)) 
-      abort_message = 'voir ci-dessus'
-      call abort_gcm(modname,abort_message,1)
-    endif
-       if (check) then
-         write(47,*)'Sortie fromcpl apres bidouille'
-         write(47,*)' read_sst = '
-         write(47,'(72f8.3)')read_sst
-         call flush(47)
-!        allocate(isst(iim, jjm+1), stat = error)
-!        isst = 0
-!        where (read_sst >0.) isst = 1
-!        write(46,'(72i1)')isst
-       endif
+      if (minval(pctsrf_new(:,is_oce)) < 0.) then
+        write(*,*)'Pb fraction ocean inferieure a 0'
+        write(*,*)'au point ',minloc(pctsrf_new(:,is_oce))
+        write(*,*)'valeur = ',minval(pctsrf_new(:,is_oce)) 
+        abort_message = 'voir ci-dessus'
+        call abort_gcm(modname,abort_message,1)
+      endif
+      if (minval(pctsrf_new(:,is_sic)) < 0.) then
+        write(*,*)'Pb fraction glace inferieure a 0'
+        write(*,*)'au point ',minloc(pctsrf_new(:,is_sic))
+        write(*,*)'valeur = ',minval(pctsrf_new(:,is_sic)) 
+        abort_message = 'voir ci-dessus'
+        call abort_gcm(modname,abort_message,1)
+      endif
     endif 
   endif                         ! fin mod(itime, nexca) == 1
Index: /LMDZ.3.3/branches/rel-LF/libf/phylmd/physiq.F
===================================================================
--- /LMDZ.3.3/branches/rel-LF/libf/phylmd/physiq.F	(revision 142)
+++ /LMDZ.3.3/branches/rel-LF/libf/phylmd/physiq.F	(revision 143)
@@ -121,5 +121,5 @@
 c======================================================================
       LOGICAL ok_journe ! sortir le fichier journalier
-      PARAMETER (ok_journe=.FALSE.)
+      PARAMETER (ok_journe=.true.)
 c
       LOGICAL ok_mensuel ! sortir le fichier mensuel
@@ -127,5 +127,5 @@
 c
       LOGICAL ok_instan ! sortir le fichier instantane
-      PARAMETER (ok_instan=.false.)
+      PARAMETER (ok_instan=.true.)
 c
       LOGICAL ok_region ! sortir le fichier regional